/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Nicolas Dolet
 * 
 * Contributor(s):
 */

package org.ow2.frascati.factory.core.instance.binding;

import java.util.Map;

import org.objectweb.fractal.bf.connectors.jsonrpc.JsonRpcConnectorConstants;
import org.eclipse.stp.sca.domainmodel.frascati.JsonRpcBinding;
import org.eclipse.stp.sca.domainmodel.frascati.FrascatiPackage;

/**
 * Bind components using a Json RPC Binding.
 *
 * @author Nicolas Dolet
 * @since 1.1
 */
@org.objectweb.fractal.fraclet.annotations.Component
public class ScaBindingJsonRpc extends AbstractRemoteBinding<JsonRpcBinding> {

  // --------------------------------------------------------------------------
  // Implementation of the abstract methods
  // --------------------------------------------------------------------------

  public String getBindingID() {
    return getID(FrascatiPackage.Literals.JSON_RPC_BINDING);
  }

  @Override
  public String getBindingFactoryPluginId() {
    return "rest";
  }

  @Override
  @SuppressWarnings("static-access")
  public void initializeBindingHints(JsonRpcBinding jsonRpcBinding, Map<String, Object> hints) {
    // set protocol specific parameter
    hints.put(JsonRpcConnectorConstants.URI, jsonRpcBinding.getUri());
  }
}
