/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 * 
 * Contributor(s): Valerio Schiavoni, Nicolas Dolet, Philippe Merle
 */

package org.ow2.frascati.factory.core.instance.binding;

import java.util.Map;
import org.eclipse.stp.sca.ScaPackage;
import org.eclipse.stp.sca.WebServiceBinding;
import org.objectweb.fractal.bf.connectors.ws.WsConnectorConstants;

/**
 * Bind components using Web Service Binding.
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version 1.1
 */
@org.objectweb.fractal.fraclet.annotations.Component
public class ScaBindingWs extends AbstractRemoteBinding<WebServiceBinding> {

  //---------------------------------------------------------------------------
  // Implementation of the abstract methods.
  // --------------------------------------------------------------------------

  public String getBindingID() {
    return getID(ScaPackage.Literals.WEB_SERVICE_BINDING);
  }

  @Override
  public String getBindingFactoryPluginId() {
    return "ws";
  }

  @Override
  @SuppressWarnings("static-access")
  public void initializeBindingHints(WebServiceBinding wsBinding, Map<String, Object> hints) {
    // set protocol specific parameter
    hints.put(WsConnectorConstants.URI, wsBinding.getUri());
    hints.put(WsConnectorConstants.WSDL_ELEMENT, wsBinding.getWsdlElement());
    hints.put(WsConnectorConstants.WSDL_LOCATION, wsBinding.getWsdlLocation());
  }
}
