/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.implementation;

import org.eclipse.stp.sca.Implementation;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.fraclet.annotations.Interface;
import org.ow2.frascati.factory.core.instance.NotSupportedException;

@Interface(name = "implementation")
public interface ScaImplementation {

  /**
   * Create SCA component
   * 
   * @param implementation -
   *          Supplied implementation informations
   * @param componentType -
   *          Component type for the component to create
   * @return Component instance if applicable
   * @throws ImplementationException 
   * @throws NotSupportedException 
   */

  public org.objectweb.fractal.api.Component create(
      Implementation implementation, ComponentType componentType) throws ImplementationException, NotSupportedException;

  /**
   * Get Implementation type 
   * 
   * @return EObject ID from the SCA model
   */

  public String getImplementationID();

}
