/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 * 
 * Contributor(s): Nicolas Dolet
 */

package org.ow2.frascati.factory.core.instance.intent;

import java.util.List;

import javax.xml.namespace.QName;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.stp.sca.Component;
import org.eclipse.stp.sca.ScaPackage;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.ow2.frascati.tinfi.control.intent.IntentHandler;
import org.ow2.frascati.tinfi.control.intent.SCABasicIntentController;

/**
 * {@link ScaIntent} implementation that set intents for SCA components
 * 
 * @author <a href="mailto:nicolas.dolet@inria.fr">Nicolas Dolet</a>
 * @version $Revision$
 */
@org.objectweb.fractal.fraclet.annotations.Component
public class ComponentIntent
     extends AbstractIntentPlugin {

  //---------------------------------------------------------------------------
  // Implementation of the abstract methods
  // --------------------------------------------------------------------------

  public int getEObjectID() {
    return ScaPackage.COMPONENT;
  }
  
  @Override
  protected List<QName> getIntentsFromModel(EObject component) {
    return ((Component) component).getRequires();
  }

  @Override
  protected String getName(EObject component) {
    return ((Component) component).getName();
  }

  @Override
  protected void addIntent(SCABasicIntentController ic, IntentHandler h,
      String itf) throws IllegalLifeCycleException {
    ic.addFcIntentHandler(h);
  }

}
