/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.runtime;

import org.objectweb.fractal.api.Type;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.fraclet.annotations.Interface;
import org.ow2.frascati.factory.core.instance.InstantiationException;

/**
 * Component for 
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version $Revision$
 */

@Interface(name = "runtime")
public interface RuntimeFactory extends FactoryLoaderItf {
  
  /**
   * Create InterfaceType using Tinfi
   * @return Tinfi component interface type
   * @throws InstantiationException
   * @since 1.1
   */
  
  public InterfaceType createInterfaceType(String arg0, String arg1, boolean arg2,
      boolean arg3, boolean arg4) throws InstantiationException;
  
  /**
   * Create ComponentType using Tinfi
   * @return Tinfi component type
   * @throws InstantiationException
   * @since 1.1
   */
  public ComponentType createComponentType(InterfaceType[] arg0) throws InstantiationException;
  
  
  /**
   * Create Component Instance
   * @return Tinfi component instance
   * @throws InstantiationException
   * @since 1.1
   */
  
  public org.objectweb.fractal.api.Component newInstance(Type arg0,
      Object arg1, Object arg2) throws InstantiationException;

}
