/***
 * OW2 FraSCAti Explorer
 * Copyright (C) 2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Author: Philippe Merle
 *
 * Contributor(s):
 * 
 */

package org.ow2.frascati.explorer.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import org.ow2.frascati.explorer.action.RunInNewThreadMenuItem;

/**
 * Is the FraSCAti Explorer plugin to show {@link Runnable} instances.
 *
 * @author Philippe Merle
 */
public class RunnablePanel extends AbstractSelectionPanel<Runnable> {

  /**
   * Default constructor creates an empty white panel with a button.
   */
  public RunnablePanel() {
    super();
    JButton button = new JButton("Run");
    add(button);
    button.addActionListener( new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        	RunInNewThreadMenuItem.runInNewThread(selected);
        }
      }
    );
  }
}
