/***
 * OW2 FraSCAti Tinfi
 * Copyright (C) 2007-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.ow2.frascati.tinfi.control.component;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.julia.type.BasicInterfaceType;
import org.osoa.sca.ComponentContext;

/**
 * This interface contains data related to the {@link ComponentContext} control
 * interface.
 *
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 1.0
 */
public interface ReconfigurableComponentContext extends ComponentContext {

    /** <code>NAME</code> of the component context control interface. */
    final public static String NAME = "sca-component-controller";
    
    /** <code>TYPE</code> of the component context control interface. */
    final public static InterfaceType TYPE =
        new BasicInterfaceType(
            NAME,
            ReconfigurableComponentContext.class.getName(),
            false, false, false );
    
    /**
     * Return the reference of the component controller associated with this
     * controller.
     */
    public Component getFcComponent();
}
